#
# ISP RAS (http://www.ispras.ru)
#
# This ruby template was automatically generated by the MicroTESK tool
# Generation started: Fri Dec 27 11:14:34 MSK 2019
#

require_relative 'minimips_base'

class SimpleGenTemplate < MiniMipsBaseTemplate
  def pre
    super
    data {
      label :data
      word rand(1, 9), rand(1, 9), rand(1, 9), rand(1, 9)
      label :end_data
      space 1
    }
  end
  
  def run
    
    add reg(_), reg(_), reg(_)
    
    addi reg(_), reg(_), _
    
    addu reg(_), reg(_), reg(_)
    
    addiu reg(_), reg(_), _
    
    sub reg(_), reg(_), reg(_)
    
    subu reg(_), reg(_), reg(_)
    
    mult reg(_), reg(_)
    
    multu reg(_), reg(_)
    
    AND reg(_), reg(_), reg(_)
    
    andi reg(_), reg(_), _
    
    OR reg(_), reg(_), reg(_)
    
    ori reg(_), reg(_), _
    
    nor reg(_), reg(_), reg(_)
    
    xor reg(_), reg(_), reg(_)
    
    xori reg(_), reg(_), _
    
    sll reg(_), reg(_), _
    
    sllv reg(_), reg(_), reg(_)
    
    sra reg(_), reg(_), _
    
    srav reg(_), reg(_), reg(_)
    
    srl reg(_), reg(_), _
    
    srlv reg(_), reg(_), reg(_)
    
    lui reg(_), _
    
    la reg(5), :data
    lw reg(_), :data, reg(5)
    
    la reg(5), :data
    sw reg(5), :data, reg(5)
    
    mfhi reg(_)
    
    mflo reg(_)
    
    mthi reg(_)
    
    mtlo reg(_)
    
    la reg(5), :data
    swc0 rcop0(5), :data, reg(5)
    
    la reg(5), :data
    lwc0 rcop0(_), :data, reg(5)
    
    mfc0 reg(_), rcop0(_)
    
    mtc0 reg(_), rcop0(_)
    
    beq reg(_), reg(_), :beq_label
    nop
    label :beq_label
    nop
    
    bgez reg(_), :bgez_label
    nop
    label :bgez_label
    nop
    
    bgezal reg(_), :bgezal_label
    nop
    label :bgezal_label
    nop
    
    bgtz reg(_), :bgtz_label
    nop
    label :bgtz_label
    nop
    
    blez reg(_), :blez_label
    nop
    label :blez_label
    nop
    
    bltz reg(_), :bltz_label
    nop
    label :bltz_label
    nop
    
    bltzal reg(_), :bltzal_label
    nop
    label :bltzal_label
    nop
    
    bne reg(_), reg(_), :bne_label
    nop
    label :bne_label
    nop
    
    slt reg(_), reg(_), reg(_)
    
    slti reg(_), reg(_), _
    
    sltiu reg(_), reg(_), _
    
    sltu reg(_), reg(_), reg(_)
    
    j :j_label
    nop
    label :j_label
    nop
    
    la reg(3), :jr_label
    jr reg(3)
    nop
    label :jr_label
    nop
    
    jal :jal_label
    nop
    label :jal_label
    nop
    
    la reg(3), :jalr_label
    jalr reg(_), reg(3)
    nop
    label :jalr_label
    nop
    
    syscall 
    
    cop0 _
    
    mips_break 
    
    nop 
  end
end
